#include <stdio.h>
#include <sys/time.h>
#include <stdlib.h>
#include <time.h>

#define TIME_DIFF(t1, t2) \
		((t2.tv_sec - t1.tv_sec) * 1000000 + (t2.tv_usec - t1.tv_usec))

#define MESURES 10
#define M 1024 // taille totale du tableau.
int main(int argc, char *argv[]) {
	long int sum255 = 0, sum0 = 0;
	unsigned char *c;
	int i, j, k, mesure, n, N;
	struct timeval tv1,tv2;

	if (argc<2) {
		fprintf(stderr,"il me faut N en paramtre\n");
		exit(EXIT_FAILURE);
	}

	N = atoi(argv[1]);
	if (N>M) {
		fprintf(stderr,"maximum autoris: %d\n",M-1);
		exit(EXIT_FAILURE);
	}

	c = malloc(M*sizeof(*c));
	for (i=0; i<M; i++)
		c[i] = 255 * (random()%2);

	for (mesure=0; mesure<MESURES; mesure++) {
		gettimeofday(&tv1,NULL);
		i = 0;
		for (k=0; k<1000; k++) {
			n = random()%(M-N); // on dmarre  une position alatoire entre 0 et M-N
			for (j=0; j<100000; j++) {
				// on parcourt 100 000 fois la portion n..n+N
				// pour N petit, le processeur arrive  se
				// souvenir quelle branche du if on va prendre
				if (c[n+i] >= (unsigned char) 128)
					sum255++;
				else
					sum0++;
				if (++i == N)
					i = 0;
			}
		}
		gettimeofday(&tv2,NULL);
		printf("sum255 %ld sum0 %ld %.3f sec\n", sum255, sum0, ((float)(TIME_DIFF(tv1,tv2)))/1000000);
	}
	return 0;
}
